---
title: XRPermissionDescriptor.mode
slug: Web/API/XRPermissionDescriptor/mode
tags:
  - API
  - AR
  - Mixed
  - Permissions
  - Property
  - Reality
  - Reference
  - Session
  - VR
  - Virtual
  - WebXR
  - WebXR API
  - WebXR Device API
  - XR
  - XRPermissionDescriptor
  - XRSessionMode
  - augmented
  - mode
---
<p>{{APIRef("WebXR Device API")}}{{SecureContext_header}}</p>

<p>The <code><strong>mode</strong></code> property of the {{domxref("XRPermissionDescriptor")}} dictionary is a string taken from the {{domxref("XRSessionMode")}} enumerated type, specifying which Web XR session mode (<code>inline</code>, <code>immersive-vr</code>, or <code>immersive-ar</code>) the described permissions will be used for.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>xrPermissionDescriptor</em> = {
  mode: <em>xrSessionMode</em>,
  requiredFeatures: <em>reqFeatureList</em>,
  optionalFeatures: <em>optFeatureList</em>
};

<em>xrPermissionDescriptor</em>.mode = <em>xrSessionMode</em>;
<em>xrMode</em> = <em>xrPermissionDescriptor</em>.mode;
</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("DOMString")}} whose value is one of the strings found in the {{domxref("XRSessionMode")}} enumerated type:</p>

<p>{{page("/en-US/docs/Web/API/XRSessionMode", "Values")}}</p>

<h2 id="Usage_notes">Usage notes</h2>

<h2 id="Examples">Examples</h2>

<p>The example below checks to ensure that permission has been granted to allow the user to use WebXR for an immersive virtual reality experience. No specific features are specified during this query; see {{domxref("XRPermissionDescriptor.requiredFeatures", "requiredFeatures")}} and {{domxref("XRPermissionDescriptor.optionalFeatures", "optionalFeatures")}} for more information on specifying features during a WebXR permission check.</p>

<pre class="brush: js">let xrPermissionDesc = {
  name: "xr",
  mode: "immersive-vr"
};

if (navigator.permissions) {
  navigator.permissions.query(xrPermissionDesc).then(({state}) =&gt; {
    switch(state) {
      case "granted":
        setupXR();
        break;
      case "prompt":
        promptAndSetupXR();
        break;
      default:
        /* do nothing otherwise */
       break;
  }
  .catch(err) {
    console.log(err);
  }
} else {
  setupXR();
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('WebXR','#dom-xrpermissiondescriptor-mode','XRPermissionDescriptor.mode')}}</td>
   <td>{{Spec2('WebXR')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.XRPermissionDescriptor.mode")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebXR_Device_API/Permissions_and_security">Permissions and security for WebXR</a></li>
 <li>{{domxref("XRPermissionStatus")}}</li>
 <li>{{domxref("navigator.permissions")}} and {{domxref("WorkerNavigator.permissions")}}</li>
 <li>{{domxref("Permissions")}}</li>
</ul>
